;========================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;========================================
;	SOUND FOR THE ZX81
;    R. Bruneaus, Sept. 1994
;    Sinc-Link Vol. 12 No. 4
;========================================

ORG 4084

@CHADD=4016
@SCANNING=0F55
@FPTOA=15CD
@FINDINT=0EA7
@PRBUFF00=403C
@PRBUFF01=403D
@PRBUFF02=403E
@PRBUFF03=403F
@PRBUFF04=4040
@PRBUFF05=4041
@PRBUFF06=4042
@PRBUFF07=4043
@SEED=4032

;==========================
;Comma check
;==========================
@Comma
	PUSH AF 
	LD A,(HL) 
	CP 1A 
	JR Z Lb408C
	RST 08 
	18			;Error Code'P'
@lb408C
	POP AF 
	RET
;==========================
;Set Reg A to parameter value (0 to 256)
;==========================
@SetA
	LD (CHADD),HL
	CALL SCANNING
	PUSH HL 
	CALL FPTOA
	POP HL 
	RET
;==========================
;Set Reg BC to parameter value (0 to 65535)
;==========================
@SetBC
	LD (CHADD),HL
	CALL SCANNING
	PUSH HL 
	CALL FINDINT
	POP HL 
	RET
;==========================
;Get small value parameter
;==========================
@GetParam
	CALL SetA
	CALL Comma
	RET
;==========================
;Get large value parameter
;==========================
@Int2BC
	CALL SetBC
	CALL Comma
	RET
;==========================
;Check for semicolon
;==========================
@SemiColon
	LD HL,(CHADD)
	LD A,(HL) 
	CP 19 
	JR Z Lb40E0
	CP 76 
	JR Z Lb40C2
@ErrorE
	RST 08
	0D 			;Error Code'E'
@lb40C2
	POP HL 
	LD (CHADD),HL
	LD BC,0000 
	RET
;==========================
;Parse BASIC line and do commands
;==========================
@Start
	LD HL,(CHADD)
	LD A,(HL) 
	CP DE 
	JR Z Lb40D4
@ErrorI
	RST 08 
	11			;Error Code'I'
@lb40D4
	PUSH HL 
	INC HL 
	LD A,(HL) 
	LD DE, Lb40C2 
	PUSH DE 
	CP E1 
	JR NZ ErrorI
	POP DE 
@lb40E0
	LD DE, SemiColon 
	PUSH DE 
	INC HL 
	LD A,(HL) 
	LD B,A 
@lb40E7
	INC HL 
	LD A,(HL) 
	CP 76 
	JR Z ErrorI
	CP 19 
	JR NZ Lb40E7
	LD A,B 
	CP 32 
	JP Z Music		;Use JR?
	CP 38 
	JP Z Sound
	CP 35 
	JP Z Play
	JP ErrorI		;Use JR?
	RST 08
	0A			;Error Code'B'
;==========================
;MUSIC command
;==========================
@Music
	INC HL 
	CALL GetParam
	CP 16 			;BUG, this is decimal value should be $10H
	JR Z ErrorM
	AND A 
	JR NZ Lb4113
	ADD A,16		;BUG, this is decimal value should be $10H
@lb4113
	LD (PRBUFF01),A
	INC HL 
	CALL GetParam
	CP 0D 
	JR NC ErrorM
	AND A 
	JR Z ErrorM
	SUB 01 
	ADD A,A 
	PUSH HL 
	LD HL, Notes 
	LD B,00 
	LD C,A 
	ADD HL,BC 
	LD A,(HL) 
	INC HL 
	LD B,(HL) 
	LD C,A 
	LD (PRBUFF03),BC
	POP HL 
	INC HL 
	CALL GetParam
	CP 07 
	JR NC ErrorM
	INC A 
	LD BC,(PRBUFF04)
	LD B,A 
	LD A,(PRBUFF03)
	JR Lb414F
@lb4148
	RR C 
	RES 7,C 
	RR A 
	AND A 
@lb414F
	DJNZ Lb4148
	LD (PRBUFF03),A
	LD A,C 
	LD (PRBUFF05),A
	INC HL 
	CALL SetA
	CP 04 
	JR NC ErrorM
	AND A 
	JR Z ErrorM
	PUSH AF 
	ADD A,07 
	LD (PRBUFF00),A
	POP AF 
	SUB 01 
	ADD A,A 
	LD (PRBUFF02),A
	INC A 
	LD (PRBUFF04),A
	PUSH HL 
	LD B,03 
	LD HL,403C 
	CALL SendData
	JP SemiColon
@ErrorM
	RST 08
	15			;Error Code'M'
;==========================
;SOUND command
;==========================
@Sound
	INC HL 
	CALL GetParam
	CP 10 
	JR NC ErrorS
	AND A 
	JR NZ Lb418F
	ADD A,10 
@lb418F
	LD (PRBUFF01),A
	INC HL 
	CALL Int2BC
	LD A,C 
	LD (PRBUFF03),A
	LD A,B 
	LD (PRBUFF05),A
	INC HL 
	CALL SetA
	CP 07 
	JR NC ErrorS
	AND A 
	JR Z ErrorS
	PUSH AF 
	CP 04 
	JR NC Lb41C2
	ADD A,07 
	LD (PRBUFF00),A
	POP AF 
	SUB 01 
	ADD A,A 
	LD (PRBUFF02),A
	INC A 
	LD (PRBUFF04),A
	JR Lb41DB
@ErrorS
	RST 08
	1B			;Error Code'S'
@Lb41C2
	ADD A,04 
	LD (PRBUFF00),A
	POP AF 
	LD A,06 
	LD (PRBUFF02),A
	LD (PRBUFF04),A
	LD A,(PRBUFF03)
	LD (PRBUFF05),A
	CP 20 
	JP NC ErrorS		;Use JR?
@lb41DB
	PUSH HL 
	LD B,03 
	LD HL,403C 
	CALL SendData
	JP SemiColon
;==========================
;PLAY command
;==========================

@Play
	INC HL 
	CALL Int2BC
	LD A,C 
	LD (PRBUFF01),A
	LD A,B 
	LD (PRBUFF03),A
	LD A,0B 
	LD (PRBUFF00),A
	INC A 
	LD (PRBUFF02),A
	INC HL 
	CALL GetParam
	CP 09			;BUG, this should be 08, range is 0 to 7
	JR NC ErrorP
	AND A 
	JR Z Lb4209		;Envelope shape 0 is correct
	ADD A,07 		;BUG, this produces envelope shapes
				;     08 09 10 11 12 13 14 which should be
				;     06 08 10 11 12 13 14 
@lb4209
	LD (PRBUFF05),A		;C13, shape value from above
	LD A,0D 		;R13
	LD (PRBUFF04),A
	LD A,07 
	LD (PRBUFF06),A
	INC HL 
	CALL GetParam
	CP 08 
	JR NC ErrorP
	SLA A 
	SLA A 
	SLA A 
	LD (PRBUFF07),A
	INC HL 
	CALL SetA
	CP 08 
	JR NC ErrorP
	PUSH HL 
	LD HL,4043 
	OR (HL) 
	CPL 
	LD (PRBUFF07),A
	CP FF 
	JR Z Lb4249
	LD B,04 
	LD HL,403C 
	CALL SendData
	JP SemiColon
@ErrorP
	RST 08
	18			;Error Code'P'
@lb4249
	XOR A 
	LD (PRBUFF00),A
	LD (PRBUFF01),A
	LD B,14 		;BUG, this is decimal value should be $0E
@lb4252
	LD HL,403C 
	LD A,(HL) 
	OUT DF,A		;Sound Card
	INC (HL) 
	INC HL 
	LD A,(HL) 
	OUT 1F,A		;User port
	DJNZ Lb4252
	LD A,07 
	OUT DF,A		;Sound Card
	LD A,FF 
	OUT 1F,A		;User port
	JP SemiColon
;==========================
;Send data to AY
;==========================
@SendData
	LD A,(HL) 
	OUT DF,A		;Sound Card
	INC HL 
	LD A,(HL) 
	OUT 1F,A		;User port
	INC HL 
	DJNZ SendData
	RET
;==========================
@Notes				;Notes table
	F1 06			;Note 01 C
	8E 06			;Note 02 C#
	30 06			;Note 03 D
	D7 05			;Note 04 D#
	83 05			;Note 05 E
	34 05			;Note 06 F
	E9 04			;Note 07 F#
	A2 04			;Note 08 G
	60 04			;Note 09 G#
	20 04			;Note 10 A
	E6 03			;Note 11 A#
	AE 03			;Note 12 B
;==========================
;LET variable=USR 17037 will give the status of the I/0 port.
;==========================
@Status
	LD A,07 
	OUT DF,A		;Sound Card
	IN A,DF			;User port
	RES 6,A 
	OUT 1F,A		;User port
	LD A,0E 
	OUT DF,A		;Sound Card
	IN A,DF			;User port
	XOR FF 
	LD C,A 
	LD B,00 
	RET
;==========================
;LET variable=USR 17059 will give ????
;This routine not referenced anywhere
;Sends the contents of SEED to AY
;==========================
@NotCalled
	LD A,07 
	OUT DF,A		;Sound Card
	IN A,DF			;User port.
	SET 6,A 
	OUT 1F,A		;User port
	LD A,0E 
	OUT DF,A		;Sound Card
	LD A,(SEED) ; GET SEED
	OUT 1F,A		;User port
	RET
;==========================
@lb42B7    ; <<< Uncharted Entry ]

	NOP 
	NOP 
	NOP 