;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================

ORG 42BE

@Seed=4032
@LAddr=09D8
@DFile=400C
@ERRSP=4002
@RAMTOP=4004
@Pointer
	00 00
@Command
	00 00
	JR SetRT
	JR DataStart
	JR MusicData
;===========================
;Lower RAMTOP by 1K
;===========================
@SetRT
	LD HL,7C00
	LD (RAMTOP),HL
	LD SP,HL 
	LD BC,3E00 
	PUSH BC 
	LD BC,0676 
	PUSH BC 
	LD (ERRSP),SP
	RST 08
	FF
;===========================
;Locate start of data
;===========================
@DataStart
	LD HL,(Seed)		;HL=Music data line number
	CALL LAddr		;Find it's address
	LD BC,0005		;Skip line header bytes
	ADD HL,BC		;HL=Start address of music data
	LD C,80			;128 characters max for credit/title
	LD A,97			;Skip over credit/title, locate inverse "*"
	CPIR
	JR Z HeaderOK
@ErrorM
	RST 08			;
        15 			;Error Code'M'
@HeaderOK
	LD(Pointer),HL
	RET
;===========================
;Process music data
;===========================
@MusicData
	XOR A			;A=0
	LD(Command),A		;Set command to 0=process data as a note
	LD HL,(Pointer)
@SkipComma
	LD A,(HL)		;Test for seperator
	CP 1A			;Seperator?
	JR NZ EOF
	INC HL			;Yes, skip over comma
	JR SkipComma
@EOF
	BIT 7,A			;Check for inverse character, EOF indicator
	JR Z Octave		;IF NOT EOF THEN GOTO Octave
	LD A,"X"		;Yes, set EOF indicator
	LD(Command),A		;and RET to BASIC
	LD BC,0000
	RET
@Octave
	CP "O"			;Octave change?
	JR NZ Time
@StorValue
	LD(Command),A
	INC HL			;O,T,R value
	LD A,(HL)
	SUB 1C			;CODE-28, convert character code to number
@SetPointer
	LD B,00			;Set BC for RET
	LD C,A
	INC HL
	LD (Pointer),HL		;Store data pointer
	RET
@Time
	CP "T"			;Time change?
	JR Z StorValue 
@Rest
	CP "R"			;Rest?
	JR Z StorValue
@Notes
	AND A			;Clear CY
	SBC A,1C		;First digit, CODE-28
	LD B,A			;B=0 or 1
	JR Z Digit2		;IF B=0 THEN GOTO Digit2
	XOR A			;Clear A & CY
	LD A,0A			;LET A=10
@Digit2
	LD B,A			;B=0 or 10 
	INC HL			;Next CHR
	LD A,(HL)		;Second digit
	SBC A,1C		;CODE-28
	ADD A,B			;A=Note value, 01 to 12
	JR SetPointer 
